// kfiledir.h version 1.2 trial
// copyright (c) KSoft 2000, 2001
//---------------------------------------------------------------------------
#ifndef kfiledirH
#define kfiledirH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <filectrl.hpp>
#include <registry.hpp>
//---------------------------------------------------------------------------
class DirScanThread;
class DynArray
{
private:
  int internalLen;
protected:
public:
  DynArray();
  ~DynArray();
  void __fastcall Clear(void);
  int __fastcall Add(int value);
  int *array;
  int step;
  int len;
};
//---------------------------------------------------------------------------
class TIco
{
private:
    HIMAGELIST FILIcons;
    TStringList* List;
    TRegistry *reg;
    TRegistry *reg1;
    AnsiString __fastcall FindDefIcon(AnsiString extension);
    int __fastcall TranslateFWI(AnsiString &str);
protected:
public:
  TIco();
  ~TIco();
  int __fastcall Add(AnsiString FileName);
  void __fastcall SetImageList(HWND ListViewHandle);
};

//---------------------------------------------------------------------------
typedef void __fastcall (__closure *TFVFileAdd)(System::TObject* Sender, TListItem* item, AnsiString File, TSearchRec sr);
class PACKAGE TFileListView : public TListView
{
private:
    int c;
    int FSearchAttr;
    bool FPass;
    DynArray* SortOrder;
    DynArray* SortTypesC;
    TIco* Ico;
    char v[150];
    AnsiString __fastcall GetSelectedFile(void);
    AnsiString FMask;
    AnsiString FDirectory;
    AnsiString FSortTypes;
    TFilterComboBox* FFilterCombo;
    TFVFileAdd FOnFileAdd;
    DirScanThread *DSThread;
    void __fastcall  ApplyComboMask(TObject *Sender);
protected:
    DYNAMIC void __fastcall Change(TListItem *Item, int i);
    DYNAMIC void __fastcall ColClick(TListColumn* Column);
    virtual void __fastcall FileAdd(TListItem* item, TSearchRec sr);
    virtual void __fastcall SetParent(TWinControl* AParent);
    void __fastcall SetSortTypes(AnsiString ASortTypes);
    void __fastcall SetDirectory(AnsiString ADirectory);
    void __fastcall SetMask(AnsiString AMask);
    void __fastcall SetFilterCombo(TFilterComboBox* AFilterComboBox);
    virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
public:
    __property int SearchAttr ={read=FSearchAttr, write=FSearchAttr};
    void __fastcall RefreshView();
    __fastcall TFileListView(TComponent* Owner);
    __fastcall ~TFileListView();
    __property AnsiString SelectedFile={read=GetSelectedFile};
    __property AnsiString Directory={read=FDirectory, write=SetDirectory};
__published:
    __property TFVFileAdd OnFileAdd={read=FOnFileAdd, write=FOnFileAdd};
    __property AnsiString Mask={read=FMask, write=SetMask};
    __property AnsiString SortTypes={read=FSortTypes, write=SetSortTypes};
    __property TFilterComboBox* FilterComboBox={read=FFilterCombo,write=SetFilterCombo};
};
//---------------------------------------------------------------------------
class PACKAGE TDirectoryTreeView : public TCustomTreeView
{
private:
  bool FPass;
  TV_ITEM *pitem;
  TImageList *FDefaultImageList;
  TImageList *FImageList;
  TFileListView *FFileListView;
  AnsiString FSelectedDir;
  char v[150];
  AnsiString __fastcall CreatePathString(TTreeNode* Node);
  AnsiString __fastcall SlashSep(AnsiString const Path, AnsiString const S);
  AnsiString __fastcall ExtDriveLetter(AnsiString label);
  TStringList* rootDrives;
  void __fastcall SetNodeImages(HTREEITEM itemID, int image, int selection, int HasChildren);
  void __fastcall SetNodeHasChildren(HTREEITEM itemID, int HasChildren);
  void __fastcall SetFileListView(TFileListView* Value);
  void __fastcall SetDefaultImages(bool Value);
  int __fastcall CheckForSubfolders(TTreeNode* node);
  TTreeNode* __fastcall FindChildNode(TTreeNode *ParentNode, AnsiString folder);
  void __fastcall AddFoldersToNode(TTreeNode* Node);
protected:
    virtual void __fastcall SetParent(TWinControl* AParent);
	virtual void __fastcall SetImageList(Controls::TImageList* Value);
    DYNAMIC bool __fastcall CanExpand(TTreeNode* Node);
    DYNAMIC void __fastcall Change(TTreeNode* Node);
    void __fastcall SetRootDrivers(void);
    void __fastcall SetSelectedDir(AnsiString ADir);
    virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
public:
    __fastcall TDirectoryTreeView(TComponent* Owner);
    __fastcall  ~TDirectoryTreeView();
    __property AnsiString SelectedDir={read=FSelectedDir, write=SetSelectedDir};
__published:
    __property TFileListView *FileList={read=FFileListView, write=SetFileListView};
	__property Controls::TImageList* ImageList={read=FImageList, write=SetImageList};
    __property ShowButtons ;
	__property BorderStyle ;
	__property DragCursor ;
	__property ShowLines ;
	__property ShowRoot ;
	__property ReadOnly ;
	__property RightClickSelect ;
	__property DragMode ;
	__property HideSelection ;
	__property Indent ;
//	__property Items ; 
	__property OnEditing ;
	__property OnEdited ;
	__property OnExpanding ;
	__property OnExpanded ;
	__property OnCollapsing ;
	__property OnCompare ;
	__property OnCollapsed ;
	__property OnChanging ;
	__property OnChange ;
	__property OnDeletion ;
	__property OnGetImageIndex ;
	__property OnGetSelectedIndex ;
	__property Align ;
	__property Enabled ;
	__property Font ;
	__property Color ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property Ctl3D ;
	__property SortType ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnClick ;
	__property OnEnter ;
	__property OnExit ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnStartDrag ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnDblClick ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property PopupMenu ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property ShowHint ;
//    __property Images;
};
//---------------------------------------------------------------------------
    class DirScanThread : public TThread
    {
    private:
        void __fastcall ChangeDirToMonitor();
        void __fastcall RefreshDir();
        int r;
    protected:
        void __fastcall Execute();
    public:
        TFileListView* FileListView;
        TMemo* M;
        HANDLE dwChangeHandles[2];
        char MonitorDirectory[MAX_PATH+1];
        __fastcall DirScanThread(bool CreateSuspended);
    }; 
//---------------------------------------------------------------------------

#endif

